Index: trunk/source/processes/electromagnetic/utils/include/G4VMultipleScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/utils/include/G4VMultipleScattering.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/include/G4VMultipleScattering.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4VMultipleScattering.hh,v 1.55 2009/02/18 12:19:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4VMultipleScattering.hh,v 1.54 2008/07/31 13:01:26 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -145,8 +145,12 @@
 			      G4bool ascii);
 
+  //------------------------------------------------------------------------
+  // Specific methods for msc processes
+  //------------------------------------------------------------------------
+
   // The function overloads the corresponding function of the base
   // class.It limits the step near to boundaries only
   // and invokes the method GetMscContinuousStepLimit at every step.
-  G4double AlongStepGetPhysicalInteractionLength(
+  virtual G4double AlongStepGetPhysicalInteractionLength(
                                             const G4Track&,
 					    G4double  previousStepSize,
@@ -188,6 +192,10 @@
   inline G4PhysicsTable* LambdaTable() const;
 
-  // access particle type 
+  //------------------------------------------------------------------------
+  // Define and access particle type 
+  //------------------------------------------------------------------------
+
   inline const G4ParticleDefinition* Particle() const;
+  inline void SetParticle(const G4ParticleDefinition*);
 
   //------------------------------------------------------------------------
@@ -195,45 +203,27 @@
   //------------------------------------------------------------------------
 
-protected:
-  // Select model in run time
-  inline G4VEmModel* SelectModel(G4double kinEnergy);
-
-public:
-  // Select model in run time
+  inline void AddEmModel(G4int, G4VEmModel*, const G4Region* region = 0);
+
   inline G4VEmModel* SelectModelForMaterial(G4double kinEnergy, 
 					    size_t& idxRegion) const;
 
-  // Add model for region, smaller value of order defines which
-  // model will be selected for a given energy interval  
-  inline void AddEmModel(G4int order, G4VEmModel*, const G4Region* region = 0);
-
-  // Access to models by index
+  // Access to models
   inline G4VEmModel* GetModelByIndex(G4int idx = 0, G4bool ver = false);
 
   //------------------------------------------------------------------------
-  // Get/Set parameters for simulation of multiple scattering
-  //------------------------------------------------------------------------
-
-  inline G4bool LateralDisplasmentFlag() const;
+  // Set parameters for simulation of multiple scattering
+  //------------------------------------------------------------------------
+
   inline void SetLateralDisplasmentFlag(G4bool val);
 
-  inline G4double Skin() const;
   inline void SetSkin(G4double val);
 
-  inline G4double RangeFactor() const;
   inline void SetRangeFactor(G4double val);
 
-  inline G4double GeomFactor() const;
   inline void SetGeomFactor(G4double val);
 
-  inline G4double PolarAngleLimit() const;
   inline void SetPolarAngleLimit(G4double val);
 
-  inline G4MscStepLimitType StepLimitType() const;
   inline void SetStepLimitType(G4MscStepLimitType val);
-
-  //------------------------------------------------------------------------
-  // Run time methods
-  //------------------------------------------------------------------------
 
 protected:
@@ -243,4 +233,8 @@
 			   G4double,
 			   G4ForceCondition* condition);
+
+  //------------------------------------------------------------------------
+  // Run time methods
+  //------------------------------------------------------------------------
 
   // This method is not used for tracking, it returns step limit
@@ -259,15 +253,34 @@
 					    G4double& currentSafety);
 
+  inline G4VEmModel* SelectModel(G4double kinEnergy);
+  // Select concrete model
+
+  inline const G4MaterialCutsCouple* CurrentMaterialCutsCouple() const; 
+
   // define current material
   inline void DefineMaterial(const G4MaterialCutsCouple* couple);
 
-  inline const G4MaterialCutsCouple* CurrentMaterialCutsCouple() const; 
+  //------------------------------------------------------------------------
+  // Access parameters of multiple scattering
+  //------------------------------------------------------------------------
 
   inline G4ParticleChangeForMSC* GetParticleChange();
 
+  inline G4double Skin() const;
+
+  inline G4double RangeFactor() const;
+
+  inline G4double GeomFactor() const;
+
+  inline G4double PolarAngleLimit() const;
+
+  inline G4MscStepLimitType StepLimitType() const;
+
+  inline G4bool LateralDisplasmentFlag() const;
 
 private:
 
   // hide  assignment operator
+
   G4VMultipleScattering(G4VMultipleScattering &);
   G4VMultipleScattering & operator=(const G4VMultipleScattering &right);
@@ -317,214 +330,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4double G4VMultipleScattering::ContinuousStepLimit(
-                                       const G4Track& track,
-                                       G4double previousStepSize,
-                                       G4double currentMinimalStep,
-                                       G4double& currentSafety)
-{
-  return GetMscContinuousStepLimit(track,previousStepSize,currentMinimalStep,
-				   currentSafety);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VMultipleScattering::SetBinning(G4int nbins)
-{
-  nBins = nbins;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4int G4VMultipleScattering::Binning() const
-{
-  return nBins;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VMultipleScattering::SetMinKinEnergy(G4double e)
-{
-  minKinEnergy = e;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VMultipleScattering::MinKinEnergy() const
-{
-  return minKinEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VMultipleScattering::SetMaxKinEnergy(G4double e)
-{
-  maxKinEnergy = e;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VMultipleScattering::MaxKinEnergy() const
-{
-  return maxKinEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetBuildLambdaTable(G4bool val)
-{
-  buildLambdaTable = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4PhysicsTable* G4VMultipleScattering::LambdaTable() const
-{
-  return theLambdaTable;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  const G4ParticleDefinition* G4VMultipleScattering::Particle() const
-{
-  return currentParticle;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VMultipleScattering::AddEmModel(G4int order, G4VEmModel* p,
-					      const G4Region* region)
-{
-  G4VEmFluctuationModel* fm = 0;
-  modelManager->AddEmModel(order, p, fm, region);
-  if(p) p->SetParticleChange(pParticleChange);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4VEmModel* G4VMultipleScattering::SelectModel(G4double kinEnergy)
-{
-  return modelManager->SelectModel(kinEnergy, currentMaterialIndex);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4VEmModel* G4VMultipleScattering::SelectModelForMaterial(
-		   G4double kinEnergy, size_t& idxRegion) const
-{
-  return modelManager->SelectModel(kinEnergy, idxRegion);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 inline 
-G4VEmModel* G4VMultipleScattering::GetModelByIndex(G4int idx, G4bool ver)
-{
-  return modelManager->GetModel(idx, ver);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  G4bool G4VMultipleScattering::LateralDisplasmentFlag() const
-{
-  return latDisplasment;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetLateralDisplasmentFlag(G4bool val)
-{
-  latDisplasment = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  G4double G4VMultipleScattering::Skin() const
-{
-  return skin;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetSkin(G4double val)
-{
-  if(val < 1.0) skin = 0.0;
-  else          skin = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  G4double G4VMultipleScattering::RangeFactor() const
-{
-  return facrange;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetRangeFactor(G4double val)
-{
-  if(val > 0.0) facrange = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  G4double G4VMultipleScattering::GeomFactor() const
-{
-  return facgeom;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetGeomFactor(G4double val)
-{
-  if(val > 0.0) facgeom = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  G4double G4VMultipleScattering::PolarAngleLimit() const
-{
-  return polarAngleLimit;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline  void G4VMultipleScattering::SetPolarAngleLimit(G4double val)
-{
-  if(val < 0.0)     polarAngleLimit = 0.0;
-  else if(val > pi) polarAngleLimit = pi;
-  else              polarAngleLimit = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4MscStepLimitType G4VMultipleScattering::StepLimitType() const
-{
-  return stepLimit;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VMultipleScattering::SetStepLimitType(G4MscStepLimitType val) 
-{
-  stepLimit = val;
-  if(val == fMinimal) facrange = 0.2;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline 
-G4double G4VMultipleScattering::GetLambda(const G4ParticleDefinition* p, 
-					  G4double& e)
-{
-  G4double x;
-  if(theLambdaTable) {
-    G4bool b;
-    x = ((*theLambdaTable)[currentMaterialIndex])->GetValue(e, b);
-  } else {
-    x = currentModel->CrossSection(currentCouple,p,e);
+void G4VMultipleScattering::DefineMaterial(const G4MaterialCutsCouple* couple)
+{
+  if(couple != currentCouple) {
+    currentCouple   = couple;
+    currentMaterialIndex = couple->GetIndex();
   }
-  if(x > DBL_MIN) x = 1./x;
-  else            x = DBL_MAX; 
-  return x;
 }
 
@@ -554,17 +364,209 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+inline G4double G4VMultipleScattering::ContinuousStepLimit(
+                                       const G4Track& track,
+                                       G4double previousStepSize,
+                                       G4double currentMinimalStep,
+                                       G4double& currentSafety)
+{
+  return GetMscContinuousStepLimit(track,previousStepSize,currentMinimalStep,
+				   currentSafety);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 inline 
-void G4VMultipleScattering::DefineMaterial(const G4MaterialCutsCouple* couple)
-{
-  if(couple != currentCouple) {
-    currentCouple   = couple;
-    currentMaterialIndex = couple->GetIndex();
+G4double G4VMultipleScattering::GetLambda(const G4ParticleDefinition* p, 
+					  G4double& e)
+{
+  G4double x;
+  if(theLambdaTable) {
+    G4bool b;
+    x = ((*theLambdaTable)[currentMaterialIndex])->GetValue(e, b);
+  } else {
+    x = currentModel->CrossSection(currentCouple,p,e);
   }
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline const G4MaterialCutsCouple* 
-G4VMultipleScattering::CurrentMaterialCutsCouple() const
+  if(x > DBL_MIN) x = 1./x;
+  else            x = DBL_MAX; 
+  return x;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4VEmModel* G4VMultipleScattering::SelectModel(G4double kinEnergy)
+{
+  return modelManager->SelectModel(kinEnergy, currentMaterialIndex);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4VEmModel* G4VMultipleScattering::SelectModelForMaterial(
+		   G4double kinEnergy, size_t& idxRegion) const
+{
+  return modelManager->SelectModel(kinEnergy, idxRegion);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VMultipleScattering::SetBinning(G4int nbins)
+{
+  nBins = nbins;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4int G4VMultipleScattering::Binning() const
+{
+  return nBins;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VMultipleScattering::SetMinKinEnergy(G4double e)
+{
+  minKinEnergy = e;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VMultipleScattering::MinKinEnergy() const
+{
+  return minKinEnergy;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VMultipleScattering::SetMaxKinEnergy(G4double e)
+{
+  maxKinEnergy = e;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VMultipleScattering::MaxKinEnergy() const
+{
+  return maxKinEnergy;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  G4bool G4VMultipleScattering::LateralDisplasmentFlag() const
+{
+  return latDisplasment;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetLateralDisplasmentFlag(G4bool val)
+{
+  latDisplasment = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4ParticleChangeForMSC* G4VMultipleScattering::GetParticleChange()
+{
+  return &fParticleChange;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  G4double G4VMultipleScattering::Skin() const
+{
+  return skin;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetSkin(G4double val)
+{
+  if(val < 1.0) skin = 0.0;
+  else          skin = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  G4double G4VMultipleScattering::RangeFactor() const
+{
+  return facrange;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetRangeFactor(G4double val)
+{
+  if(val > 0.0) facrange = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  G4double G4VMultipleScattering::GeomFactor() const
+{
+  return facgeom;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetGeomFactor(G4double val)
+{
+  if(val > 0.0) facgeom = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  G4double G4VMultipleScattering::PolarAngleLimit() const
+{
+  return polarAngleLimit;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetPolarAngleLimit(G4double val)
+{
+  if(val < 0.0)     polarAngleLimit = 0.0;
+  else if(val > pi) polarAngleLimit = pi;
+  else              polarAngleLimit = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4MscStepLimitType G4VMultipleScattering::StepLimitType() const
+{
+  return stepLimit;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VMultipleScattering::SetStepLimitType(G4MscStepLimitType val) 
+{
+  stepLimit = val;
+  if(val == fMinimal) facrange = 0.2;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  void G4VMultipleScattering::SetBuildLambdaTable(G4bool val)
+{
+  buildLambdaTable = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline  const G4ParticleDefinition* G4VMultipleScattering::Particle() const
+{
+  return currentParticle;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4PhysicsTable* G4VMultipleScattering::LambdaTable() const
+{
+  return theLambdaTable;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline 
+const G4MaterialCutsCouple* G4VMultipleScattering::CurrentMaterialCutsCouple() const
 {
   return currentCouple;
@@ -573,7 +575,18 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4ParticleChangeForMSC* G4VMultipleScattering::GetParticleChange()
-{
-  return &fParticleChange;
+inline void G4VMultipleScattering::AddEmModel(G4int order, G4VEmModel* p,
+					      const G4Region* region)
+{
+  G4VEmFluctuationModel* fm = 0;
+  modelManager->AddEmModel(order, p, fm, region);
+  if(p) p->SetParticleChange(pParticleChange);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline 
+G4VEmModel* G4VMultipleScattering::GetModelByIndex(G4int idx, G4bool ver)
+{
+  return modelManager->GetModel(idx, ver);
 }
 
Index: trunk/source/processes/electromagnetic/utils/src/G4EmCalculator.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4EmCalculator.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4EmCalculator.cc	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4EmCalculator.cc,v 1.46 2009/02/24 09:56:03 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4EmCalculator.cc,v 1.44 2008/08/03 18:47:15 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -755,11 +755,6 @@
     if(currentProcess) currentProcessName = currentProcess->GetProcessName();
 
-    if(p->GetParticleType() == "nucleus" 
-       && currentParticleName != "deuteron"  
-       && currentParticleName != "triton"
-       && currentParticleName != "alpha+"
-       && currentParticleName != "helium"
-       && currentParticleName != "hydrogen"
-      ) {
+    if(p->GetParticleType() == "nucleus" &&
+       currentParticleName  != "deuteron" && currentParticleName != "triton") {
       baseParticle = theGenericIon;
       massRatio = baseParticle->GetPDGMass()/p->GetPDGMass();
Index: trunk/source/processes/electromagnetic/utils/src/G4EmConfigurator.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4EmConfigurator.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4EmConfigurator.cc	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4EmConfigurator.cc,v 1.4 2009/02/26 11:33:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4EmConfigurator.cc,v 1.3 2008/11/21 12:30:29 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -117,7 +117,5 @@
   G4String fname = "";
   if(fm) fname = fm->GetName();
-  G4String mname = "";
-  if(mod) mname = mod->GetName();
-  AddModelForRegion(particleName, processName, mname, regionName,
+  AddModelForRegion(particleName, processName, mod->GetName(), regionName,
 		    emin, emax, fname);
 }
@@ -205,9 +203,5 @@
 
 	for(G4int i=0; i<nm; i++) {
-          G4String mname = "";
-          if(modelList[i]) mname = modelList[i]->GetName();
-          G4String fname = "";
-          if(flucModelList[i]) fname = flucModelList[i]->GetName();
-	  if(modelName == mname && flucModelName == fname &&
+	  if(modelName == modelList[i]->GetName() &&
              (particleList[i] == "" || particleList[i] == particleName) ) {
 	    mod  = modelList[i];
@@ -220,20 +214,11 @@
 
 	if(!mod) {
-
-	  // set fluctuation model for ionisation processes
-          if(fluc && ptype == eloss) {
-	    G4VEnergyLossProcess* p = reinterpret_cast<G4VEnergyLossProcess*>(proc);
-	    p->SetFluctModel(fluc);
-	 
-	  } else {
-	    G4cout << "### G4EmConfigurator WARNING: fails to find a model <"
-		   << modelName << "> for process <" 
-		   << processName << "> and " << particleName 
-		   << G4endl;
-	    if(flucModelName != "") {
-	      G4cout << "                            fluctuation model <" 
-		     << flucModelName << G4endl;
-	    }
-	  }
+	  G4cout << "### G4EmConfigurator WARNING: fails to find a model <"
+		 << modelName << "> for process <" 
+		 << processName << "> and " << particleName 
+		 << G4endl;
+	  if(flucModelName != "")  
+	    G4cout << "                            fluctuation model <" 
+		   << flucModelName << G4endl;
 	} else {
 
Index: trunk/source/processes/electromagnetic/utils/src/G4EmProcessOptions.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4EmProcessOptions.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4EmProcessOptions.cc	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4EmProcessOptions.cc,v 1.26 2009/02/18 14:43:27 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4EmProcessOptions.cc,v 1.24 2008/04/17 10:33:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -59,5 +59,4 @@
 #include "G4VMultipleScattering.hh"
 #include "G4Region.hh"
-#include "G4RegionStore.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -393,38 +392,19 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void G4EmProcessOptions::ActivateDeexcitation(const G4String& pname, 
-					      G4bool val, 
-					      const G4String& reg)
-{
-  G4RegionStore* regionStore = G4RegionStore::GetInstance();
-  const G4Region* r = 0;
-  if(reg == "" || reg == "World") {
-    r = regionStore->GetRegion("DefaultRegionForTheWorld", false);
-  } else {
-    r = regionStore->GetRegion(reg, false);
-  }
-  if(!r) {
-    G4cout << "G4EmProcessOptions::ActivateDeexcitation ERROR: G4Region <"
-	   << reg << "> not found, the command ignored" << G4endl;
-    return;
-  }
-
-  const std::vector<G4VEnergyLossProcess*>& v =
-        theManager->GetEnergyLossProcessVector();
-  std::vector<G4VEnergyLossProcess*>::const_iterator itr;
-  for(itr = v.begin(); itr != v.end(); itr++) {
-    G4VEnergyLossProcess* p = *itr;
-    if(p) {
-      if(pname == p->GetProcessName()) p->ActivateDeexcitation(val,r);
-    }
-  }
-  const std::vector<G4VEmProcess*>& w =
-        theManager->GetEmProcessVector();
-  std::vector<G4VEmProcess*>::const_iterator itp;
-  for(itp = w.begin(); itp != w.end(); itp++) {
-    G4VEmProcess* q = *itp;
-    if(q) {
-      if(pname == q->GetProcessName()) q->ActivateDeexcitation(val,r);
-    }
+void G4EmProcessOptions::ActivateDeexcitation(G4bool val, const G4Region* r)
+{
+  const std::vector<G4VEnergyLossProcess*>& v =
+        theManager->GetEnergyLossProcessVector();
+  std::vector<G4VEnergyLossProcess*>::const_iterator itr;
+  for(itr = v.begin(); itr != v.end(); itr++) {
+    G4VEnergyLossProcess* p = *itr;
+    if(p) p->ActivateDeexcitation(val,r);
+  }
+  const std::vector<G4VEmProcess*>& w =
+        theManager->GetEmProcessVector();
+  std::vector<G4VEmProcess*>::const_iterator itp;
+  for(itp = w.begin(); itp != w.end(); itp++) {
+    G4VEmProcess* q = *itp;
+    if(q) q->ActivateDeexcitation(val,r);
   }
 }
Index: trunk/source/processes/electromagnetic/utils/src/G4EnergyLossMessenger.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4EnergyLossMessenger.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4EnergyLossMessenger.cc	(revision 991)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EnergyLossMessenger.cc,v 1.37 2009/02/18 14:43:27 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4EnergyLossMessenger.cc,v 1.35 2008/10/20 13:27:45 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -178,19 +178,4 @@
   aplCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
 
-  deexCmd = new G4UIcommand("/process/em/deexcitation",this);
-  deexCmd->SetGuidance("Set deexcitation flag per process and G4Region.");
-  deexCmd->SetGuidance("  procName  : process name");
-  deexCmd->SetGuidance("  flag      : flag");
-  deexCmd->SetGuidance("  regName   : G4Region name");
-
-  G4UIparameter* pName = new G4UIparameter("pName",'s',false);
-  deexCmd->SetParameter(pName);
-
-  G4UIparameter* flag = new G4UIparameter("flag",'s',false);
-  deexCmd->SetParameter(flag);
-
-  G4UIparameter* regName = new G4UIparameter("regName",'s',false);
-  deexCmd->SetParameter(regName);
-
   dedxCmd = new G4UIcmdWithAnInteger("/process/eLoss/binsDEDX",this);
   dedxCmd->SetGuidance("Set number of bins for DEDX tables");
@@ -274,5 +259,4 @@
   delete MinSubSecCmd;
   delete StepFuncCmd;
-  delete deexCmd;
   delete eLossDirectory;
   delete mscDirectory;
@@ -336,13 +320,4 @@
   }
 
-  if (command == deexCmd) {
-    G4String s1 (""), s2(""), s3("");
-    G4bool b = false;
-    std::istringstream is(newValue);
-    is >> s1 >> s2 >> s3;
-    if(s2 == "true") b = true;
-    opt->ActivateDeexcitation(s1,b,s3);
-  }
-
   if (command == mscCmd) {
     if(newValue == "Minimal") 
Index: trunk/source/processes/electromagnetic/utils/src/G4LossTableBuilder.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4LossTableBuilder.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4LossTableBuilder.cc	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4LossTableBuilder.cc,v 1.28 2009/02/18 16:24:47 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4LossTableBuilder.cc,v 1.27 2008/07/22 15:55:15 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -132,9 +132,7 @@
       G4double dedx1  = pv->GetValue(elow, b);
 
-      //G4cout << "nbins= " << nbins << " dedx1= " << dedx1 << G4endl;
-
       // protection for specific cases dedx=0
       if(dedx1 == 0.0) {
-        for (size_t k=1; k<nbins-1; k++) {
+        for (size_t k=1; k<nbins; k++) {
           bin0++;
           elow  = pv->GetLowEdgeEnergy(k);
@@ -145,14 +143,6 @@
       }
 
-      //G4cout << "nbins= " << nbins << " elow= " << elow << " ehigh= " << ehigh << G4endl;
       // initialisation of a new vector
       G4PhysicsLogVector* v = new G4PhysicsLogVector(elow, ehigh, nbins);
-      // dedx is exect zero
-      if(nbins <= 2) {
-	v->PutValue(0,1000.);
-	v->PutValue(1,2000.);
-	G4PhysicsTableHelper::SetPhysicsVector(rangeTable, i, v);
-	return;
-      }
       v->SetSpline(splineFlag);
 
Index: trunk/source/processes/electromagnetic/utils/src/G4VEmFluctuationModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/utils/src/G4VEmFluctuationModel.cc	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/src/G4VEmFluctuationModel.cc	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4VEmFluctuationModel.cc,v 1.4 2009/02/19 11:25:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4VEmFluctuationModel.cc,v 1.3 2008/07/15 16:56:39 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -65,10 +65,3 @@
 }
 
-void G4VEmFluctuationModel::InitialiseMe(const G4ParticleDefinition*)
-{}
 
-void G4VEmFluctuationModel::SetParticleAndCharge(const G4ParticleDefinition*, 
-						 G4double)
-{}
-
-
